import sys, string, os, win32com.client
from MetaReplace import *
# Create the Geoprocessor object
GP = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")

Input_GDBs = sys.argv[1]
Template_Location = sys.argv[2]
Place_Keywords = sys.argv[3]

Input_GDB_List = Input_GDBs.split(";")
Place_Keywords = Place_Keywords.replace("\'", "")
Place_Keyword_List = Place_Keywords.split(";")

for Input_GDB in Input_GDB_List:
    GP.Workspace = Input_GDB
         
    fds = GP.ListDatasets("*", "featuredataset")
    GMAP_Code = fds.Next() # Get the GMAP code from the feature dataset
       
    while GMAP_Code: # For each GMAP code feature dataset...
        Metadata_Location = Input_GDB.replace("\\" + GMAP_Code + "_geology.mdb", "")
        GP.AddMessage("Adding Place Keywords to feature classes in " + GMAP_Code + " feature dataset in " + Input_GDB + "...\n")
        GP.Workspace = Input_GDB + "\\" + GMAP_Code
        fcs = GP.ListFeatureClasses() # Get the list of feature classes in the feature dataset
        fc = fcs.Next()
        while fc: # For each feature class
            meta_file = Metadata_Location + "\\" + fc + ".txt"

            if GP.Exists(meta_file):
                for Place_Keyword in Place_Keyword_List:
                    AddPlaceKeyword(meta_file, Template_Location, Place_Keyword)
            else:
                GP.AddWarning("File " + meta_file + " does not exist!")

            fc = fcs.Next()

        if GP.Exists(Metadata_Location + "\\" + GMAP_Code + "_metadata.txt"):
            for Place_Keyword in Place_Keyword_List:
                AddPlaceKeyword(Metadata_Location + "\\" + GMAP_Code + "_metadata.txt", Template_Location, Place_Keyword)
                
        if GP.Exists(Metadata_Location + "\\" + GMAP_Code + "unit.txt"):
            for Place_Keyword in Place_Keyword_List:
                AddPlaceKeyword(Metadata_Location + "\\" + GMAP_Code + "unit.txt", Template_Location, Place_Keyword)

        if GP.Exists(Metadata_Location + "\\" + GMAP_Code + "map.txt"):
            for Place_Keyword in Place_Keyword_List:
                AddPlaceKeyword(Metadata_Location + "\\" + GMAP_Code + "map.txt", Template_Location, Place_Keyword)

        if GP.Exists(Metadata_Location + "\\" + GMAP_Code + "_geology_hlp.txt"):
            for Place_Keyword in Place_Keyword_List:
                AddPlaceKeyword(Metadata_Location + "\\" + GMAP_Code + "_geology_hlp.txt", Template_Location, Place_Keyword)
                
        GMAP_Code = fds.Next()
        
